
unit Log;

interface

procedure ToLog(const AFile, ALine, AMessage: string; const AForceRewrite: boolean = FALSE);

implementation

uses
  SysUtils;

procedure ToLog(const AFile, ALine, AMessage: string; const AForceRewrite: boolean);
var
  LFile: text;
  LName: string;
begin
  LName := ChangeFileExt(ParamStr(0), '.log');
  Assign(LFile, LName);
  if FileExists(LName) and not AForceRewrite then
    Append(LFile)
  else
    Rewrite(LFile);
  WriteLn(LFile, Format('%s %s(%s) %s', [TimeToStr(Time), AFile, ALine, AMessage]));
  Close(LFile);
end;

end.
